<?php
namespace Teknisa\CADEST\Services;


use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class GrupoPromocionalService {
    protected $connection;

    public function __construct($entityManager) {
        $this->connection = $entityManager->getConnection();
        date_default_timezone_set('America/Sao_Paulo');
    }
    
    
    
    public function deleteGrupoPromocional($row){
        $param = array(
            ':CDGRUPROMOC' => $row['CDGRUPROMOC'],
            ':NRORG' => $row['NRORG']
           );
        
        $this->connection->executeQuery(self::DELETE_PRODUTO_GRUPO_PROMOCIONAL, $param);
        $this->connection->executeQuery(self::DELETE_GRUPO_PROMOCIONAL, $param);  
    }
  
   public function deleteGrupoPromocionalPadrao($row){  
         
            $param = array(
                ':CDFILIAL' => null,
                ':CDGRUPROMOC' => $row['CDGRUPROMOC'],
                ':CDPRODPROMOCAO' => $row['CDPRODPROMOCAO'],
                ':NRSEQGRPROMO' => $row['NRSEQGRPROMO'],
                ':QTPRGRUPPROMOC' => $row['QTPRGRUPPROMOC'],
                ':QTPRGRUPROMIN'  => $row['QTPRGRUPROMIN'],
                ':IDAPLICADESC'  => $row['IDAPLICADESC'],
                ':IDIMPGRPROMO' => $row['IDIMPGRPROMO'],
                ':CDGRUPMUTEX' => $row['CDGRUPMUTEX'],
                ':DTFINVGGRPROMO' => $row['DTFINVGGRPROMO'],
                ':DTINIVGGRPROMO' => $row['DTINIVGGRPROMO'],
                ':NRORDPROMOGRUP' => $row['NRORDPROMOGRUP'],
                ':NRORG' => $row['NRORG']
           );
           
        $this->connection->executeQuery(self::DELETE_FILHO_PADRAO, $param);
        return $this->connection->executeQuery(self::DELETE_GRUPO_PROMO_PADRAO, $param);
    }
   
   public function deletegrupopromocionalLocal($row){
       
        $param = array(
            ':CDFILIAL' => null,
            ':CDGRUPROMOC' => $row['CDGRUPROMOC'],
            ':CDPRODPROMOCAO' => $row['CDPRODPROMOCAO'],
            ':NRSEQGRPROMOFIL' => $row['NRSEQGRPROMOFIL'],
            ':QTPRGRUPPROMFIL' => $row['QTPRGRUPPROMFIL'],
            ':QTPRGRUPROMINFIL' => $row['QTPRGRUPROMINFIL'],
            ':IDAPLICADESCFIL' => $row['IDAPLICADESCFIL'],
            ':IDIMPGRPROMOFIL' => $row['IDIMPGRPROMOFIL'],
            ':CDGRUPMUTEXFIL' => $row['CDGRUPMUTEXFIL'],
            ':DTFINVGGRPROFIL' => $row['DTFINVGGRPROFIL'],
            ':DTINIVGGRPROFIL' => $row['DTINIVGGRPROFIL'],
            ':NRORDPROMOGRUPFIL' => $row['NRORDPROMOGRUPFIL'],
            ':NRORG' => $row['NRORG']
        );
       
       if(array_key_exists('CDFILIAL', $row)){
            $param['CDFILIAL'] =  $row['CDFILIAL'];
            $this->connection->executeQuery(self::DELETE_FILHO_LOCAL, $param); 
            return $this->connection->executeQuery(self::DELETE_GRUPO_PROMO_LOCAL, $param);
        }   
       
   }
   
    public function updateImprCupom($CDPRODUTO, $CDFILIAL) {
        $params = array(
            ':CDPRODUTO' => $CDPRODUTO,
            ':CDFILIAL'  => $CDFILIAL
        );
       
        $this->connection->executeQuery(self::UPDATE_GRUPO_PROMO_PADRAO, $params);
        $this->connection->executeQuery(self::UPDATE_GRUPO_PROMO_LOCAL,  $params);
    }
    const UPDATE_GRUPO_PROMO_PADRAO = "
        UPDATE GRUPROMOCPROD
           SET IDIMPGRPROMO = 'N' 
         WHERE CDPRODPROMOCAO = :CDPRODUTO
    ";
        
    const UPDATE_GRUPO_PROMO_LOCAL = "
        UPDATE GRUPROMOCPRFIL
           SET IDIMPGRPROMOFIL = 'N'
         WHERE CDPRODPROMOCAO = :CDPRODUTO 
           AND CDFILIAL = :CDFILIAL
    ";
    
    const SELECT_DESCONTO_PROMOCIONAL = '
        SELECT COUNT(*) as TOTAL
        FROM DESGRUPROMOCPR
        WHERE CDGRUPROMOC = :CDGRUPROMOC         
        AND NRORG = :NRORG
    ';
    
    const DELETE_GRUPO_PROMOCIONAL = '
        DELETE FROM GRUPROMOC
        WHERE CDGRUPROMOC = :CDGRUPROMOC
        AND NRORG = :NRORG
    ';
    
    const DELETE_PRODUTO_GRUPO_PROMOCIONAL = '
    DELETE FROM PRODGRUPROMOC 
        WHERE CDGRUPROMOC = :CDGRUPROMOC
        AND NRORG = :NRORG
    ';
       
    const DELETE_GRUPO_PROMO_PADRAO = '
         DELETE FROM GRUPROMOCPROD 
          WHERE CDGRUPROMOC = :CDGRUPROMOC 
          AND  NRSEQGRPROMO = :NRSEQGRPROMO
            AND CDPRODPROMOCAO = :CDPRODPROMOCAO 
             AND QTPRGRUPPROMOC = :QTPRGRUPPROMOC
             AND QTPRGRUPROMIN = :QTPRGRUPROMIN
             AND IDAPLICADESC = :IDAPLICADESC
             AND IDIMPGRPROMO = :IDIMPGRPROMO
            AND NRORG = :NRORG
    ';
        
    const DELETE_GRUPO_PROMO_LOCAL = '
    DELETE FROM GRUPROMOCPRFIL 
        WHERE CDGRUPROMOC = :CDGRUPROMOC 
        AND NRSEQGRPROMOFIL = :NRSEQGRPROMOFIL
        AND QTPRGRUPPROMFIL = :QTPRGRUPPROMFIL
        AND QTPRGRUPROMINFIL = :QTPRGRUPROMINFIL
        AND IDAPLICADESCFIL = :IDAPLICADESCFIL
        AND IDIMPGRPROMOFIL = :IDIMPGRPROMOFIL
        AND CDPRODPROMOCAO = :CDPRODPROMOCAO 
        AND NRORG = :NRORG
        AND CDFILIAL = :CDFILIAL
    ';
        
    const DELETE_FILHO_PADRAO = '
    DELETE FROM DESGRUPROMOCPR 
        WHERE CDGRUPROMOC = :CDGRUPROMOC 
        AND NRSEQGRPROMO = :NRSEQGRPROMO
        AND CDPRODPROMOCAO = :CDPRODPROMOCAO 
        AND NRORG = :NRORG
    ';
    
     const DELETE_FILHO_LOCAL = '
    DELETE FROM DESGRUPROMPRFIL 
        WHERE CDGRUPROMOC = :CDGRUPROMOC 
        AND NRSEQGRPROMOFIL = :NRSEQGRPROMOFIL
        AND CDPRODPROMOCAO = :CDPRODPROMOCAO 
        AND NRORG = :NRORG
        AND CDFILIAL = :CDFILIAL
    ';
    
}