CREATE OR REPLACE PROCEDURE APAGA_PARAM_CTBL(
   P_CDTIPOOPER VARCHAR2,
   P_CDOPERADOR OPERADOR.CDOPERADOR%TYPE,
   P_CDFILIAL   FILIAL.CDFILIAL%TYPE)
IS

BEGIN
   FOR C_CURSOR IN
      (SELECT CDITEMPARACTB
         FROM ITEMPARACTB
        WHERE INSTR(P_CDTIPOOPER, CDITEMPARACTB) > 0
        ORDER BY CDITEMPARACTB)LOOP

      IF C_CURSOR.CDITEMPARACTB = '00001' THEN -- Tipo de Retirada
         UPDATE   TIPORETI
            SET CDCONTCTBL  = NULL,
                IDCONTABCMV = 'N',
                CDHISTPADR  = NULL;

      ELSIF C_CURSOR.CDITEMPARACTB = '00002' THEN      -- Tipo de Operao - Entrada
         UPDATE TIPOOPERAC
            SET CDCONTFORCLI = NULL,
                CDCONTPROD   = NULL,
                CDHISTPADR   = NULL,
                IDCOAVRIMPVRPROD = 'N',
                CDCTBLTPOPERCMV = NULL,
                CDREFLOTECTBTO  = NULL,
                IDDTCONTAB      = NULL
          WHERE IDENTRSAIDOP = 'E';

      ELSIF C_CURSOR.CDITEMPARACTB = '00003' THEN      -- Tipo de Operao - Sada
         UPDATE TIPOOPERAC
            SET CDCONTFORCLI = NULL,
                CDCONTPROD   = NULL,
                CDHISTPADR   = NULL,
                IDCOAVRIMPVRPROD = 'N',
                CDCTBLTPOPERCMV = NULL,
                CDREFLOTECTBTO  = NULL,
                IDDTCONTAB      = NULL
          WHERE IDENTRSAIDOP = 'S';

       ELSIF C_CURSOR.CDITEMPARACTB = '00004' THEN   -- TIPO DE DBITO BANCRIO
          UPDATE TPDEBIBANC
             SET CDCONTCTBL   = NULL,
                 CDHISTPADR   = NULL,
                 CDREFLOTECTBTDB = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00005' THEN -- TIPO DE CRDITO BANCRIO
          UPDATE TPCREDBANC
             SET CDHISTPADR   = NULL,
                 CDCONTCTBL   = NULL,
                 IDCTBLCRBANC = 'S',
                 CDREFLOTECTBTCB = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00006' THEN -- Tipo de conta a receber
          UPDATE TIPOCTRECEBER
             SET CDCONTCTBL  = NULL,
                 CDREFLOTECTBTR = NULL,
                 CDHISTPADR     = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00007' THEN -- Tipo de conta a pagar
          UPDATE TIPOCTPAGAR
             SET CDCONTCTBL = NULL,
                 CDHISTPADR = NULL,
                 CDREFLOTECTBTP = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00008' THEN -- Tipo de baixa a receber
          UPDATE TIPOBAIXAREC
             SET CDHISTPADR = NULL,
                 CDREFLOTECTBTBR = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00009' THEN -- Tipo de baixa a pagar
          UPDATE TIPOBAIXAPAG
             SET CDHISTPADR = NULL,
                 CDREFLOTECTBTBP = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00010' THEN -- Tipo de ajuste de conta a receber
          UPDATE TIPOAJRECEBER
             SET CDHISTPADR      = NULL,
                 CDCONTCTBL      = NULL,
                 CDREFLOTECTBTAR = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00011' THEN -- Tipo de ajuste de conta a pagar
          UPDATE TIPOAJPAGAR
             SET CDHISTPADR = NULL,
                 CDCONTCTBL = NULL,
                 CDREFLOTECTBTAP = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00012' THEN -- Produto
          UPDATE PRODUTO
             SET CDCTBLENTRPR = NULL,
                 CDCTBLSAIDPR = NULL,
                 CDCTBLPRODPR = NULL,
                 CDCTBLCPROPR = NULL,
                 CDCTBLAJUSPR = NULL,
                 CDCTBLIMPLPR = NULL,
                 CDCTBLPRACPR = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00013' THEN -- Padro
          UPDATE PARAMCTBL
             SET CDCONTDIFE    = NULL,
                 CDCTBLPERDPA  = NULL,
                 CDCONTDITEN   = NULL,
                 CDCONTDITSA   = NULL,
                 CDREFLOTECTBL = NULL,
                 CDCONTFORN    = NULL,
                 CDCONTCLIE    = NULL;

          UPDATE PARAMEMPRESA
             SET CDCONFORNEM   = NULL,
                 CDCONCLIEEM   = NULL,
                 CDCONTDIFEEM  = NULL,
                 CDCTBLPERDEM  = NULL;

          UPDATE PARAMFILIAL
             SET CDCONCLIEFI   = NULL,
                 CDCONFORNFI   = NULL,
                 CDCONTDIFEFI  = NULL,
                 CDCTBLPERDFI  = NULL;
       ELSIF C_CURSOR.CDITEMPARACTB = '00014' THEN -- Integrao contbil
          UPDATE PARAMCTBL
             SET DTINTCTBBCO   = NULL,
                 DTINTCTBPAG   = NULL,
                 DTINTCTBREC   = NULL,
                 DTINTCTBDFE   = NULL,
                 DTINTCTBDFS   = NULL,
                 DTINTCTBEXP   = NULL,
                 DTINTCTBEST   = NULL,
                 DTINTCTBFAC   = NULL,
                 DTINTCTBFAS   = NULL,
                 DTINTCTBFIS   = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00015' THEN -- Imposto
          UPDATE IMPOSTO
             SET CDCCTBLDESP = NULL,
                 CDCCTBLPASS = NULL,
                 CDCCTBLATIV = NULL,
                 CDCCTBLDADM = NULL;

          UPDATE CCTBIMPFORN
             SET CDCCTBATIVIF = NULL,
                 CDCCTBDADMIF = NULL,
                 CDCCTBPASSIF = NULL,
                 CDCCTBDESPIF = NULL
           WHERE IDTPIJURIMPO = 'J';

          UPDATE CCTBIMPFORN
             SET CDCCTBATIVIF = NULL,
                 CDCCTBDADMIF = NULL,
                 CDCCTBPASSIF = NULL,
                 CDCCTBDESPIF = NULL
           WHERE IDTPIJURIMPO = 'F';

          UPDATE CCTBIMPFORN
             SET CDCCTBATIVIF = NULL,
                 CDCCTBDADMIF = NULL,
                 CDCCTBPASSIF = NULL,
                 CDCCTBDESPIF = NULL
           WHERE IDTPIJURIMPO = 'I';

          UPDATE CCTBIMPFORN
             SET CDCCTBATIVIF = NULL,
                 CDCCTBDADMIF = NULL,
                 CDCCTBPASSIF = NULL,
                 CDCCTBDESPIF = NULL
           WHERE IDTPIJURIMPO = 'O';

          UPDATE CTBIMPTPOPER
             SET CDCCTBATIVTO = NULL,
                 CDCCTBDADMTO = NULL,
                 CDCCTBPASSTO = NULL,
                 CDCCTBDESPTO = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00016' THEN  -- Estoque
          UPDATE PARAMESTOQUE
             SET CDHISTPADRETEST = NULL,
                 CDHISTPADRETPRO = NULL,
                 CDHISTPADSAIEST = NULL,
                 CDHISTPADRAJIMP = NULL,
                 CDREFLOTECTBRET = NULL,
                 CDREFLOTECTBPRO = NULL,
                 CDREFLOTECTBSAI = NULL,
                 CDREFLOTECTBIMP = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00017' THEN -- Encargo
          UPDATE ENCARGO
             SET CDCTBLENTREN = NULL,
                 CDCTBLSAIDEN = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00018' THEN -- Fornecedor
          UPDATE FORNECEDOR
             SET CDCONTCTBL   = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00019' THEN -- Filial
          UPDATE FILIAL
             SET CDCONTCTBL = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00020' THEN -- Conta corrente
          UPDATE CONTCORR
             SET CDCONTCTBL = NULL;

       ELSIF C_CURSOR.CDITEMPARACTB = '00021' THEN -- Cliente
          UPDATE CLIENTE
             SET CDCONTCTBL = NULL;
       
       END IF;
       
       INSERT INTO LOGEXCLITPARCTB
          (CDITEMPARACTB, DTEXCLITEM, CDFILIAL, CDOPERINCLUSAO)
       VALUES
          (C_CURSOR.CDITEMPARACTB, SYSDATE, P_CDFILIAL, P_CDOPERADOR);
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('APAGA_PARAM_CTBL','5.40.000'); END;
/