/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DIPD                                                     */
/* Tabela : DIETPADR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_DIPD
BEFORE INSERT OR UPDATE OR DELETE
ON DIETPADR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUDIPD := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDDIETPAD ,0)   <> NVL(:NEW.CDDIETPAD ,0))   OR
         (NVL(:OLD.DSDIETPAD ,0)   <> NVL(:NEW.DSDIETPAD ,0))   OR
         (NVL(:OLD.IDTIPODIET,0)   <> NVL(:NEW.IDTIPODIET,0))   OR
         (NVL(:OLD.CDDIETGRUP,0)   <> NVL(:NEW.CDDIETGRUP,0))   OR
         (NVL(:OLD.IDFORMDIET,0)   <> NVL(:NEW.IDFORMDIET,0))   OR
         (NVL(:OLD.IDDIETAATIVA,0) <> NVL(:NEW.IDDIETAATIVA,0)) THEN
         :NEW.DTULTATUDIPD := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('DIETPADR', '', 'CDDIETPAD='||:OLD.CDDIETPAD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE DIETPADR MODIFY DTULTATUDIPD DEFAULT SYSDATE
/
