/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_MEDIPRATO                                                   */
/* Tabela : MEDIPRATO                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 14/12/2004 - Rafael dos Santos Lopes                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MEDIPRATO
BEFORE INSERT OR UPDATE OR DELETE
ON MEDIPRATO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMEPR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.VRPESOMED,0) <> NVL(:NEW.VRPESOMED,0))THEN
         :NEW.DTULTATUMEPR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MEDIPRATO', '', 'CDMEDICASE='||:OLD.CDMEDICASE||';CDFILAUXPRAT='||:OLD.CDFILAUXPRAT||';CDPRATO='||:OLD.CDPRATO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MEDIPRATO MODIFY DTULTATUMEPR DEFAULT SYSDATE
/

